#if 0
#define parent(i) (i > 1 ? (i)/2 : 1)
#define left(i)   (2*(i))
#define right(i)  (2*(i)+1) 

void heapfy(int *a, int *c, int *ind, int i, int n)
{
  int l, t;
  l = left(i);
  while (l<=n){
    if (l<n && c[l+1] < c[l])
      l++;
    if (c[i] <= c[l])
      break;
    /* exchange */
    ind[a[i]] = l;
    ind[a[l]] = i;
    t = a[i];
    a[i] = a[l];
    a[l] = t;
    t = c[i];
    c[i] = c[l];
    c[l] = t;
    /* recursive call */
    i = l;
    l = left(i);
  }
}


void build_heap(int *a, int *c, int *ind, int n)
{
  int i;
  for (i=n/2; i>0; i--)
    heapfy(a, c, ind, i, n);
}

int extract_min(int *a, int *c, int *ind, int n)
{
  int min, t;
  ind[a[1]] = n;
  ind[a[n]] = 1;
  min = a[1];
  a[1] = a[n];
  a[n] = min;
  t = c[1];
  c[1] = c[n];
  c[n] = t;
  heapfy(a, c, ind, 1, n-1);
  return min;
}

void adjust(int *a, int *c, int *ind, int i, int n)
{
  int t, v=i, p=parent(i), changed=0;
  while (v > 1 && c[p] > c[v]){
    ind[a[v]] = p;
    ind[a[p]] = v;
    t = a[v];
    a[v] = a[p];
    a[p] = t;
    t = c[v];
    c[v] = c[p];
    c[p] = t;
    changed = 1;
    v = p;
    p = parent(p);
  }
  if (!changed)
    heapfy(a, c, ind, i, n);
}
#endif


/* find the shortest path from one vertex to all others
   unsing Dijkstra's algorithm */
#if 0
listvert *shortest_path(Graph *G, vert v, vert dest)
{
  int i, u, num, custo, hsize, nVert= gr_nverts(G);
  listvert *aux, *header = NULL;
  graph_node *n;

  memset(pi, 0, sizeof(int)*(nVert+1));
  for (i = 1; i <= nVert; i++) {
    dist[i]   = INF;
    indice[i] = verts[i] = i;
  }

  dist[1] = 0;
  verts[1] = v;
  indice[1] = v;
  verts[v] = 1;
  indice[v] = 1;
  hsize = nVert;
  for (num = 0; num < nVert; num++) {
    u = extract_min(verts, dist, indice, hsize--);
    if (u == dest) {
      header = new_list_vert ();
      header->v = u;
      header->prox = 0;
      i = u;
      while (pi[i] != 0) {
	aux = new_list_vert ();
	aux->v = pi[i];
	aux->prox = header;
	header = aux;
	i = pi[i];
      }
      return header;
    }
    /* relax the constraints */
    for (n = G[u].prox; n; n=n->prox){
      if (dist[indice[u]] < INF){
	custo = dist[indice[u]] + GGetCost(G, u, n->v);
	if (dist[indice[n->v]] > custo) {
	  dist[indice[n->v]] = custo;
	  pi[n->v] = u; 
	  adjust(verts, dist, indice, indice[n->v], hsize);
	}
      }
    }
  }
  return 0;
}

listvert *shortest_path_dijkstra(Graph *G, vert v, vert dest)
{
  int i;
  listvert *aux, *header = NULL;

  header = new_list_vert ();
  header->v = dest;
  header->prox = 0;
  i = dest;
  while (Pi[v][i] != 0) {
    aux = new_list_vert ();
    aux->v = Pi[v][i];
    aux->prox = header;
    header = aux;
    i = Pi[v][i];
  }
  return header;
}
#endif
