#ifndef __PPC_H
#define __PPC_H


#define IDM_FILE_NEW     100
#define IDM_FILE_OPEN    101
#define IDM_FILE_SAVE    102
#define IDM_FILE_SAVEAS  103
#define IDM_FILE_EXIT    104

#define IDM_COLOR_SOURCE	200
#define IDM_COLOR_DEST		201
#define IDM_COLOR_NODE		202
#define IDM_COLOR_LINE		203
#define IDM_COLOR_BACK		204
#define IDM_COLOR_SOL		205
#define IDM_COLOR_DEFAULT	206



#define IDM_HELP_SOBRE  300

#define IDT_TOOLBAR	400

#define IDM_GRAPH_SOURCE   500
#define IDM_GRAPH_DEST     501
#define IDM_GRAPH_EXECUTE  502
#define IDM_GRAPH_REDEFINE 503
#define IDM_GRAPH_STOP     504
#define IDM_GRAPH_NUMVERT  505

#define IDM_GRAPH_ADDAREST   550
#define IDM_GRAPH_ADDVERTEX  551
#define IDM_GRAPH_DELAREST   552


#define IDC_NVERT 1001
#define IDC_SPIN  1002

enum Program_state {
  STAT_SELECT,
  STAT_DRAW_SOURCE,
  STAT_DRAW_DEST
};

#define WM_EXECUTE	(WM_USER) 
#define WM_STOPATEAMS	(WM_USER)+1
#define WM_ENTER	(WM_USER)+2
#define WM_ESC		(WM_USER)+3
#define WM_CHANGEGRAPH	(WM_USER)+4
#define WM_UPDATEINFO	(WM_USER)+5
#define WM_SAVEYOURSELF	(WM_USER)+6
#define WM_END_FILE_OPERATION	(WM_USER)+7
#define WM_READGRAPH	(WM_USER)+8


HWND 
CreatePPCW(HWND parent, int x1, int y1, int x2, int y2, int numVerts);


void
RegisterPPCW();

void 
DebugInt(int i);

void 
RedrawPPCWindow();

void
RegisterPPCInfo();

HWND 
CreatePPCInfo(HWND parent, int x1, int y1, int x2, int y2);


void
RedrawInfo();


void
EnablePPCButton(int command, int opt);
#endif
